//NIST/ITL StRD
//Dataset Name:  Wampler2 (Wampler2.dat)
//
//File Format:   ASCII
//               Certified Values  (lines 31 to 50)
//               Data              (lines 61 to 81)
//
//Procedure:     Linear Least Squares Regression
//
//Reference:     Wampler, R. H. (1970). 
//               A Report of the Accuracy of Some Widely-Used Least 
//               Squares Computer Programs. 
//               Journal of the American Statistical Association, 65, pp. 549-565.
//           
//Data:          1 Response Variable (y)
//               1 Predictor Variable (x)
//               21 Observations
//               Higher Level of Difficulty
//               Generated Data
//
//Model:         Polynomial Class
//               6 Parameters (B0,B1,...,B5)
//
//               y = B0 + B1*x + B2*(x**2) + B3*(x**3)+ B4*(x**4) + B5*(x**5)
//
//               Certified Regression Statistics
//
//                                           Standard Deviation
//     Parameter         Estimate               of Estimate
//
//        B0        1.00000000000000         0.000000000000000
//        B1        0.100000000000000        0.000000000000000
//        B2        0.100000000000000E-01    0.000000000000000
//        B3        0.100000000000000E-02    0.000000000000000
//        B4        0.100000000000000E-03    0.000000000000000
//        B5        0.100000000000000E-04    0.000000000000000
//
Est=[1 1e-1 1e-2 1e-3 1e-4]';
//     Residual
//     Standard Deviation   0.000000000000000
//
//     R-Squared            1.00000000000000
//
//
//               Certified Analysis of Variance Table
//
//Source of Degrees of     Sums of               Mean  
//Variation  Freedom       Squares              Squares           F Statistic
//              
//Regression   5       6602.91858365167     1320.58371673033       Infinity
//Residual    15       0.000000000000000    0.000000000000000
//
//Data:          y       x
yx=[
            1.00000    0
            1.11111    1
            1.24992    2
            1.42753    3
            1.65984    4
            1.96875    5
            2.38336    6
            2.94117    7
            3.68928    8
            4.68559    9
            6.00000   10
            7.71561   11
            9.92992   12
           12.75603   13
           16.32384   14
           20.78125   15
           26.29536   16
           33.05367   17
           41.26528   18
           51.16209   19
           63.00000   20
];
[b,stat]=linregr(yx,'y x','1 x x.^2 x.^3 x.^4 x.^5','y')
printf('NIST reference solution: '); printf('%e ',Est);
linregr(yx,'y x')
